/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.velocitycore.commands;

import de.steamwar.linkage.Linked;
import de.steamwar.velocitycore.VelocityCore;
import de.steamwar.velocitycore.discord.util.AuthManager;
import de.steamwar.command.SWCommand;
import de.steamwar.messages.Chatter;
import net.dv8tion.jda.api.entities.User;

import java.util.Base64;
import java.util.logging.Level;

@Linked
public class VerifyCommand extends SWCommand {

    public VerifyCommand() {
        super("verify");
    }

    @Register(description = "VERIFY_USAGE")
    public void genericCommand(Chatter sender, String code) {
        byte[] bytes;
        try {
            bytes = Base64.getDecoder().decode(code);
        } catch (IllegalArgumentException e) {
            sender.system("VERIFY_INVALID");
            return;
        }

        if(bytes.length != 16) {
            sender.system("VERIFY_INVALID");
            return;
        }

        User user = AuthManager.connectAuth(sender.user(), code);
        if(user != null) {
            VelocityCore.getLogger().log(Level.INFO,"%s Verified with Discorduser: %s".formatted(sender.user().getUserName(), user.getIdLong()));
            sender.system("VERIFY_SUCCESS", user.getAsTag());
        } else {
            sender.system("VERIFY_INVALID");
        }
    }
}
